/**
 * qsort: Esercizio 1
 *
 * Utilizzando qsort, porta i pari a inizio array, i dispari in fondo
 * e ordina i pari in modo crescente e i dispari in modo decrescente.
 */

#include <stdio.h>
#include <stdlib.h>

int *leggi(int *N)
{
   int *A;
   int i;

   scanf("%d", N);
   A = (int *)malloc(sizeof(int)* (*N));

   for ( i = 0; i < *N; i++ )
     scanf("%d", A+i);

   return A;
}


/* Confrontatore. Ogni numero pari e' minore
 * di un numero dispari. L'ordinamento
 * tra elementi della stessa classe segue
 * quanto richiesto. 
 */
int confronta(const void *i1, const void *i2)
{
   int val1 = *(int *)i1;  
   int val2 = *(int *)i2;

   /* L'ordinamento tra un pari e un dispari
    * viene riflesso tra le loro classi di
    * resto modulo 2. */
   if ( val1 % 2 != val2 % 2 )  
     return (val1 % 2) - (val2 % 2);

   if ( ( val1 % 2 ) == 0 )
     return val1 - val2;
   else
     return val2 - val1;
}


int 
main()
{
   int N, i;
   int *array = leggi(&N);

   qsort( array, N, sizeof(int), confronta);

   for ( i = 0; i < N; i++ ) 
    printf("%d ", array[i]);
   printf("\n");
}

 
